diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/matrix-array-test-suite.cc ns-3.38/src/core/test/matrix-array-test-suite.cc
--- ns-3.37/src/core/test/matrix-array-test-suite.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/core/test/matrix-array-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
@@ -0,0 +1,369 @@
+/*
+ * Copyright (c) 2022 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Biljana Bojovic <bbojovic@cttc.es>
+ */
+
+#include "ns3/log.h"
+#include "ns3/matrix-array.h"
+#include "ns3/test.h"
+
+/**
+ * \file
+ * \ingroup core-tests
+ * \ingroup matrixArray
+ * \ingroup matrixArray-tests
+ * MatrixArray test suite
+ */
+namespace ns3
+{
+
+namespace tests
+{
+
+NS_LOG_COMPONENT_DEFINE("MatrixArrayTest");
+
+/**
+ * \ingroup matrixArray-tests
+ *  MatrixArray test for testing constructors
+ */
+template <class T>
+class MatrixArrayTestCase : public TestCase
+{
+  public:
+    MatrixArrayTestCase<T>() = default;
+    /**
+     * Constructor
+     *
+     * \param [in] name reference name
+     */
+    MatrixArrayTestCase<T>(const std::string name);
+
+    /** Destructor. */
+    ~MatrixArrayTestCase<T>() override;
+    /**
+     * \brief Copy constructor.
+     * Instruct the compiler to generate the implicitly declared copy constructor
+     */
+    MatrixArrayTestCase<T>(const MatrixArrayTestCase<T>&) = default;
+    /**
+     * \brief Copy assignment operator.
+     * Instruct the compiler to generate the implicitly declared copy assignment operator.
+     * \return A reference to this MatrixArrayTestCase
+     */
+    MatrixArrayTestCase<T>& operator=(const MatrixArrayTestCase<T>&) = default;
+    /**
+     * \brief Move constructor.
+     * Instruct the compiler to generate the implicitly declared move constructor
+     */
+    MatrixArrayTestCase<T>(MatrixArrayTestCase<T>&&) = default;
+    /**
+     * \brief Move assignment operator.
+     * Instruct the compiler to generate the implicitly declared copy constructor
+     * \return A reference to this MatrixArrayTestCase
+     */
+    MatrixArrayTestCase<T>& operator=(MatrixArrayTestCase<T>&&) = default;
+
+  protected:
+  private:
+    void DoRun() override;
+};
+
+template <class T>
+MatrixArrayTestCase<T>::MatrixArrayTestCase(const std::string name)
+    : TestCase(name)
+{
+}
+
+template <class T>
+MatrixArrayTestCase<T>::~MatrixArrayTestCase<T>()
+{
+}
+
+template <class T>
+void
+MatrixArrayTestCase<T>::DoRun()
+{
+    // test multiplication of matrices (MatrixArray containing only 1 matrix)
+    MatrixArray<T> m1 = MatrixArray<T>(2, 3);
+    MatrixArray<T> m2 = MatrixArray<T>(m1.GetNumCols(), m1.GetNumRows());
+    for (auto i = 0; i < m1.GetNumRows(); ++i)
+    {
+        for (auto j = 0; j < m1.GetNumCols(); ++j)
+        {
+            m1(i, j) = 1;
+            m2(j, i) = 1;
+        }
+    }
+    MatrixArray<T> m3 = m1 * m2;
+    NS_LOG_INFO("m1:" << m1);
+    NS_LOG_INFO("m2:" << m2);
+    NS_LOG_INFO("m3 = m1 * m2:" << m3);
+    NS_TEST_ASSERT_MSG_EQ(m3.GetNumRows(),
+                          m1.GetNumRows(),
+                          "The number of rows in resulting matrix is not correct");
+    NS_TEST_ASSERT_MSG_EQ(m3.GetNumCols(),
+                          m2.GetNumCols(),
+                          "The number of cols in resulting matrix is not correct");
+    NS_TEST_ASSERT_MSG_EQ(m3.GetNumRows(),
+                          m3.GetNumCols(),
+                          "The number of rows and cols should be equal");
+    for (auto i = 0; i < m3.GetNumCols(); ++i)
+    {
+        for (auto j = 0; j < m3.GetNumRows(); ++j)
+        {
+            NS_TEST_ASSERT_MSG_EQ(std::real(m3(i, j)),
+                                  m1.GetNumCols(),
+                                  "The element value should be " << m1.GetNumCols());
+        }
+    }
+
+    // multiplication with a scalar value
+    MatrixArray<T> m4 = m3 * (static_cast<T>(5.0));
+    for (auto i = 0; i < m4.GetNumCols(); ++i)
+    {
+        for (auto j = 0; j < m4.GetNumRows(); ++j)
+        {
+            NS_TEST_ASSERT_MSG_EQ(m3(i, j) * (static_cast<T>(5.0)),
+                                  m4(i, j),
+                                  "The values are not equal");
+        }
+    }
+    NS_LOG_INFO("m4 = m3 * 5:" << m4);
+
+    // test multiplication of arrays of matrices
+    MatrixArray<T> m5 = MatrixArray<T>(2, 3, 2);
+    MatrixArray<T> m6 = MatrixArray<T>(m5.GetNumCols(), m5.GetNumRows(), m5.GetNumPages());
+    for (auto p = 0; p < m5.GetNumPages(); ++p)
+    {
+        for (auto i = 0; i < m5.GetNumRows(); ++i)
+        {
+            for (auto j = 0; j < m5.GetNumCols(); ++j)
+            {
+                m5(i, j, p) = 1;
+                m6(j, i, p) = 1;
+            }
+        }
+    }
+    MatrixArray<T> m7 = m5 * m6;
+    NS_TEST_ASSERT_MSG_EQ(m7.GetNumRows(),
+                          m5.GetNumRows(),
+                          "The number of rows in resulting matrix is not correct");
+    NS_TEST_ASSERT_MSG_EQ(m7.GetNumCols(),
+                          m6.GetNumCols(),
+                          "The number of cols in resulting matrix is not correct");
+    NS_TEST_ASSERT_MSG_EQ(m7.GetNumRows(),
+                          m7.GetNumCols(),
+                          "The number of rows and cols should be equal");
+
+    for (auto p = 0; p < m7.GetNumPages(); ++p)
+    {
+        for (auto i = 0; i < m7.GetNumCols(); ++i)
+        {
+            for (auto j = 0; j < m7.GetNumRows(); ++j)
+            {
+                NS_TEST_ASSERT_MSG_EQ(std::real(m7(i, j, p)),
+                                      m5.GetNumCols(),
+                                      "The element value should be " << m5.GetNumCols());
+            }
+        }
+    }
+    // test ostream operator
+    NS_LOG_INFO("m5:" << m5);
+    NS_LOG_INFO("m6:" << m6);
+    NS_LOG_INFO("m7 = m5 * m6:" << m7);
+
+    // test transpose function
+    MatrixArray<T> m8 = m5.Transpose();
+    NS_TEST_ASSERT_MSG_EQ(m6, m8, "These two matrices should be equal");
+    NS_LOG_INFO("m8 = m5.Transpose ()" << m8);
+
+    // test 1D array creation, i.e. vector and transposing it
+    MatrixArray<T> m9 = MatrixArray<T>(std::vector<T>({0, 1, 2, 3, 4, 5, 6, 7}));
+    NS_TEST_ASSERT_MSG_EQ((m9.GetNumRows() == 8) && (m9.GetNumCols() == 1) &&
+                              (m9.GetNumPages() == 1),
+                          true,
+                          "Creation of vector is not correct.");
+
+    NS_LOG_INFO("Vector:" << m9);
+    NS_LOG_INFO("Vector after transposing:" << m9.Transpose());
+
+    // Test basic operators
+    MatrixArray<T> m10 =
+        MatrixArray<T>(m9.GetNumRows(), m9.GetNumCols(), m9.GetNumPages(), m9.GetValues());
+    NS_TEST_ASSERT_MSG_EQ(m10, m9, "m10 and m9 should be equal");
+    m10 -= m9;
+    NS_TEST_ASSERT_MSG_NE(m10, m9, "m10 and m9 should not be equal");
+    m10 += m9;
+    NS_TEST_ASSERT_MSG_EQ(m10, m9, "m10 and m9 should be equal");
+    m10 = m9;
+    NS_TEST_ASSERT_MSG_EQ(m10, m9, "m10 and m9 should be equal");
+    m10 = m9 + m9;
+    NS_TEST_ASSERT_MSG_NE(m10, m9, "m10 and m9 should not be equal");
+    m10 = m10 - m9;
+    NS_TEST_ASSERT_MSG_EQ(m10, m9, "m10 and m9 should be equal");
+
+    // test multiplication by using an initialization matrixArray
+    std::valarray<int> a{0, 1, 2, 3, 4, 5, 0, 1, 2, 3, 4, 5};
+    std::valarray<int> b{0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1};
+    std::valarray<int> c{2, 3, 4, 6, 2, 3, 4, 6};
+    std::valarray<T> aCasted(a.size());
+    std::valarray<T> bCasted(b.size());
+    std::valarray<T> cCasted(c.size());
+
+    for (size_t i = 0; i < a.size(); ++i)
+    {
+        aCasted[i] = static_cast<T>(a[i]);
+    }
+    for (size_t i = 0; i < b.size(); ++i)
+    {
+        bCasted[i] = static_cast<T>(b[i]);
+    }
+    for (size_t i = 0; i < c.size(); ++i)
+    {
+        cCasted[i] = static_cast<T>(c[i]);
+    }
+    MatrixArray<T> m11 = MatrixArray<T>(2, 3, 2, aCasted);
+    MatrixArray<T> m12 = MatrixArray<T>(3, 2, 2, bCasted);
+    MatrixArray<T> m13 = m11 * m12;
+    MatrixArray<T> m14 = MatrixArray<T>(2, 2, 2, cCasted);
+    NS_TEST_ASSERT_MSG_EQ(m13.GetNumCols(),
+                          m14.GetNumCols(),
+                          "The number of columns is not as expected.");
+    NS_TEST_ASSERT_MSG_EQ(m13.GetNumRows(),
+                          m14.GetNumRows(),
+                          "The number of rows is not as expected.");
+    NS_TEST_ASSERT_MSG_EQ(m13, m14, "The values are not equal.");
+    NS_LOG_INFO("m11:" << m11);
+    NS_LOG_INFO("m12:" << m12);
+    NS_LOG_INFO("m13 = matrixArrayA * matrixArrayB:" << m13);
+
+    // test MultiplyByLeftAndRightMatrix
+    std::valarray<int> d{1, 1, 1};
+    std::valarray<int> e{1, 1};
+    std::valarray<int> f{1, 2, 3, 1, 2, 3, 1, 2, 3, 1, 2, 3};
+    std::valarray<int> g{12, 12};
+    std::valarray<T> dCasted(d.size());
+    std::valarray<T> eCasted(e.size());
+    std::valarray<T> fCasted(f.size());
+    std::valarray<T> gCasted(g.size());
+    for (size_t i = 0; i < d.size(); ++i)
+    {
+        dCasted[i] = static_cast<T>(d[i]);
+    }
+    for (size_t i = 0; i < e.size(); ++i)
+    {
+        eCasted[i] = static_cast<T>(e[i]);
+    }
+    for (size_t i = 0; i < f.size(); ++i)
+    {
+        fCasted[i] = static_cast<T>(f[i]);
+    }
+    for (size_t i = 0; i < g.size(); ++i)
+    {
+        gCasted[i] = static_cast<T>(g[i]);
+    }
+    MatrixArray<T> m15 = MatrixArray<T>(1, 3, dCasted);
+    MatrixArray<T> m16 = MatrixArray<T>(2, 1, eCasted);
+    MatrixArray<T> m17 = MatrixArray<T>(3, 2, 2, fCasted);
+    MatrixArray<T> m18 = MatrixArray<T>(1, 1, 2, gCasted);
+    MatrixArray<T> m19 = m17.MultiplyByLeftAndRightMatrix(m15, m16);
+    NS_TEST_ASSERT_MSG_EQ(m19, m18, "The matrices should be equal.");
+
+    // test MultiplyByLeftAndRightMatrix
+    std::valarray<int> h{1, 3, 2, 2, 4, 0};
+    std::valarray<int> j{2, 2, 3, 4, 1, 3, 0, 5};
+    std::valarray<int> k{1, 2, 0, 0, 2, 3, 4, 1, 2, 3, 4, 1, 1, 2, 0, 0, 2, 3, 4, 1, 2, 3, 4, 1};
+    std::valarray<int> l{144, 132, 128, 104, 144, 132, 128, 104};
+    std::valarray<T> hCasted(h.size());
+    std::valarray<T> jCasted(j.size());
+    std::valarray<T> kCasted(k.size());
+    std::valarray<T> lCasted(l.size());
+    for (size_t i = 0; i < h.size(); ++i)
+    {
+        hCasted[i] = static_cast<T>(h[i]);
+    }
+    for (size_t i = 0; i < j.size(); ++i)
+    {
+        jCasted[i] = static_cast<T>(j[i]);
+    }
+    for (size_t i = 0; i < k.size(); ++i)
+    {
+        kCasted[i] = static_cast<T>(k[i]);
+    }
+    for (size_t i = 0; i < l.size(); ++i)
+    {
+        lCasted[i] = static_cast<T>(l[i]);
+    }
+    MatrixArray<T> m20 = MatrixArray<T>(2, 3, hCasted);
+    MatrixArray<T> m21 = MatrixArray<T>(4, 2, jCasted);
+    MatrixArray<T> m22 = MatrixArray<T>(3, 4, 2, kCasted);
+    MatrixArray<T> m23 = MatrixArray<T>(2, 2, 2, lCasted);
+    MatrixArray<T> m24 = m22.MultiplyByLeftAndRightMatrix(m20, m21);
+    NS_TEST_ASSERT_MSG_EQ(m24, m23, "The matrices should be equal.");
+    NS_LOG_INFO("m20:" << m20);
+    NS_LOG_INFO("m21:" << m21);
+    NS_LOG_INFO("m22:" << m22);
+    NS_LOG_INFO("m24 = m20 * m22 * m21" << m24);
+
+    // test initialization with moving
+    NS_LOG_INFO("size() of lCasted before move: " << lCasted.size());
+    MatrixArray<T> m25 = MatrixArray<T>(2, 2, 2, std::move(lCasted));
+    NS_LOG_INFO("size() of lCasted after move: " << lCasted.size());
+    NS_LOG_INFO("m25.GetSize ()" << m25.GetSize());
+    NS_TEST_ASSERT_MSG_EQ(lCasted.size(), 0, "The size of lCasted should be 0.");
+
+    NS_LOG_INFO("size() of hCasted before move: " << hCasted.size());
+    MatrixArray<T> m26 = MatrixArray<T>(2, 3, std::move(hCasted));
+    NS_LOG_INFO("size() of hCasted after move: " << hCasted.size());
+    NS_LOG_INFO("m26.GetSize ()" << m26.GetSize());
+    NS_TEST_ASSERT_MSG_EQ(hCasted.size(), 0, "The size of hCasted should be 0.");
+
+    NS_LOG_INFO("size() of jCasted before move: " << jCasted.size());
+    MatrixArray<T> m27 = MatrixArray<T>(std::move(jCasted));
+    NS_LOG_INFO("size() of jCasted after move: " << jCasted.size());
+    NS_LOG_INFO("m27.GetSize ()" << m27.GetSize());
+    NS_TEST_ASSERT_MSG_EQ(hCasted.size(), 0, "The size of jCasted should be 0.");
+}
+
+/**
+ * \ingroup matrixArray-tests
+ * MatrixArray test suite
+ */
+class MatrixArrayTestSuite : public TestSuite
+{
+  public:
+    /** Constructor. */
+    MatrixArrayTestSuite();
+};
+
+MatrixArrayTestSuite::MatrixArrayTestSuite()
+    : TestSuite("matrix-array-test")
+{
+    AddTestCase(new MatrixArrayTestCase<double>("Test MatrixArray<double>"));
+    AddTestCase(
+        new MatrixArrayTestCase<std::complex<double>>("Test MatrixArray<std::complex<double>>"));
+    AddTestCase(new MatrixArrayTestCase<int>("Test MatrixArray<int>"));
+}
+
+/**
+ * \ingroup matrixArray-tests
+ * MatrixArrayTestSuite instance variable.
+ */
+static MatrixArrayTestSuite g_matrixArrayTestSuite;
+
+} // namespace tests
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/names-test-suite.cc ns-3.38/src/core/test/names-test-suite.cc
--- ns-3.37/src/core/test/names-test-suite.cc	2022-11-01 17:37:24.475395000 -0700
+++ ns-3.38/src/core/test/names-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
@@ -713,7 +713,7 @@
 
     Ptr<TestObject> objectNotThere = CreateObject<TestObject>();
     found = Names::FindPath(objectNotThere);
-    NS_TEST_ASSERT_MSG_EQ(found, "", "Unexpectedly found a non-existent Object");
+    NS_TEST_ASSERT_MSG_EQ(found.empty(), true, "Unexpectedly found a non-existent Object");
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/random-variable-stream-test-suite.cc ns-3.38/src/core/test/random-variable-stream-test-suite.cc
--- ns-3.37/src/core/test/random-variable-stream-test-suite.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/core/test/random-variable-stream-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
@@ -1835,7 +1835,7 @@
     double lambda = 1.0;
 
     // Note that Erlang distribution is equal to the gamma distribution
-    // when k is an iteger, which is why the gamma distribution's cdf
+    // when k is an integer, which is why the gamma distribution's cdf
     // function can be used here.
     for (std::size_t i = 0; i < N_BINS; ++i)
     {
@@ -1930,7 +1930,7 @@
     double lambda = 1.0;
 
     // Note that Erlang distribution is equal to the gamma distribution
-    // when k is an iteger, which is why the gamma distribution's cdf
+    // when k is an integer, which is why the gamma distribution's cdf
     // function can be used here.
     for (std::size_t i = 0; i < N_BINS; ++i)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/simulator-test-suite.cc ns-3.38/src/core/test/simulator-test-suite.cc
--- ns-3.37/src/core/test/simulator-test-suite.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/core/test/simulator-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
@@ -73,7 +73,7 @@
      */
     uint64_t NowUs();
     /**
-     * Checks that the events has been detroyed.
+     * Checks that the events has been destroyed.
      */
     void Destroy();
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/splitstring-test-suite.cc ns-3.38/src/core/test/splitstring-test-suite.cc
--- ns-3.37/src/core/test/splitstring-test-suite.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/core/test/splitstring-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
@@ -0,0 +1,158 @@
+/*
+ * Copyright (c) 2022 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+#include "ns3/string.h"
+#include "ns3/test.h"
+
+namespace ns3
+{
+
+namespace tests
+{
+
+/**
+ * \file
+ * \ingroup core-tests
+ * SplitString test suite implementation.
+ */
+
+/**
+ * \ingroup core-tests
+ * \defgroup environ-var-tests Environment variable caching tests
+ */
+
+/**
+ * \ingroup core-tests
+ *
+ * SplitString tests.
+ */
+class SplitStringTestCase : public TestCase
+{
+  public:
+    /** Constructor */
+    SplitStringTestCase();
+
+    /** Destructor */
+    ~SplitStringTestCase() override = default;
+
+  private:
+    /** Run the tests */
+    void DoRun() override;
+
+    /**
+     * Read \p str and check that it contains only the key,value pairs
+     * from \p expect.
+     * \param where The test condition being checked.
+     * \param str The environment variable to parse and check.
+     * \param expect The set of key,values expected.
+     */
+    void Check(const std::string& where, const std::string& str, const StringVector& expect);
+
+    /** Test suite delimiter. */
+    const std::string m_delimiter{":|:"};
+
+}; // class SplitStringTestCase
+
+SplitStringTestCase::SplitStringTestCase()
+    : TestCase("split-string")
+{
+}
+
+void
+SplitStringTestCase::Check(const std::string& where,
+                           const std::string& str,
+                           const StringVector& expect)
+{
+    const StringVector res = SplitString(str, m_delimiter);
+
+    // Print the res and expect
+    std::cout << where << ": '" << str << "'\nindex\texpect[" << expect.size() << "]\t\tresult["
+              << res.size() << "]" << (expect.size() != res.size() ? "\tFAIL SIZE" : "")
+              << "\n    ";
+    NS_TEST_EXPECT_MSG_EQ(expect.size(),
+                          res.size(),
+                          "res and expect have different number of entries");
+    for (std::size_t i = 0; i < std::max(res.size(), expect.size()); ++i)
+    {
+        const std::string r = (i < res.size() ? res[i] : "''" + std::to_string(i));
+        const std::string e = (i < expect.size() ? expect[i] : "''" + std::to_string(i));
+        const bool ok = (r == e);
+        std::cout << i << "\t'" << e << (ok ? "'\t== '" : "'\t!= '") << r
+                  << (!ok ? "'\tFAIL MATCH" : "'") << "\n    ";
+        NS_TEST_EXPECT_MSG_EQ(e, r, "res[i] does not match expect[i]");
+    }
+    std::cout << std::endl;
+}
+
+void
+SplitStringTestCase::DoRun()
+{
+    // Test points
+
+    // Empty string
+    Check("empty", "", {""});
+
+    // No delimiter
+    Check("no-delim", "token", {"token"});
+
+    // Extra leading, trailing delimiter: ":string",  "string:"
+    Check("front-:|:", ":|:token", {"", "token"});
+    Check("back-:|:", "token:|:", {"token", ""});
+
+    // Double delimiter: ":|::|:token", "token:|::|:"
+    Check("front-:|::|:", ":|::|:token", {"", "", "token"});
+    Check("back-:|::|:", "token:|::|:", {"token", "", ""});
+
+    // Two tokens: "token1:|:token2"
+    Check("two", "token1:|:token2", {"token1", "token2"});
+
+    // Extra/double delimiters:|: ":|::|:token1:|:token2", ":|:token1:|:token2",
+    // "token1:|::|:token2", "token1:|:token2:|:",
+    Check(":|::|:two", ":|::|:token1:|:token2", {"", "", "token1", "token2"});
+    Check(":|:one:|:two", ":|:token1:|:token2", {"", "token1", "token2"});
+    Check("double:|:", "token1:|::|:token2", {"token1", "", "token2"});
+    Check("two:|:", "token1:|:token2:|::|:", {"token1", "token2", "", ""});
+}
+
+/**
+ * \ingroup typeid-tests
+ *
+ * TypeId test suites.
+ */
+class SplitStringTestSuite : public TestSuite
+{
+  public:
+    SplitStringTestSuite();
+};
+
+SplitStringTestSuite::SplitStringTestSuite()
+    : TestSuite("split-string")
+{
+    AddTestCase(new SplitStringTestCase);
+}
+
+/**
+ * \ingroup environ-var-tests
+ * Static variable for test initialization.
+ */
+static SplitStringTestSuite g_SplitStringTestSuite;
+
+} // namespace tests
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/threaded-test-suite.cc ns-3.38/src/core/test/threaded-test-suite.cc
--- ns-3.37/src/core/test/threaded-test-suite.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/core/test/threaded-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
@@ -289,11 +289,16 @@
     ThreadedSimulatorTestSuite()
         : TestSuite("threaded-simulator")
     {
-        std::string simulatorTypes[] = {"ns3::RealtimeSimulatorImpl", "ns3::DefaultSimulatorImpl"};
-        std::string schedulerTypes[] = {"ns3::ListScheduler",
-                                        "ns3::HeapScheduler",
-                                        "ns3::MapScheduler",
-                                        "ns3::CalendarScheduler"};
+        std::string simulatorTypes[] = {
+            "ns3::RealtimeSimulatorImpl",
+            "ns3::DefaultSimulatorImpl",
+        };
+        std::string schedulerTypes[] = {
+            "ns3::ListScheduler",
+            "ns3::HeapScheduler",
+            "ns3::MapScheduler",
+            "ns3::CalendarScheduler",
+        };
         unsigned int threadCounts[] = {0, 2, 10, 20};
         ObjectFactory factory;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/time-test-suite.cc ns-3.38/src/core/test/time-test-suite.cc
--- ns-3.37/src/core/test/time-test-suite.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/core/test/time-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
@@ -94,7 +94,7 @@
      * \tparam T type of division value
      *
      * \param t Time value to divide
-     * \param expected Expected result of the divsion
+     * \param expected Expected result of the division
      * \param val Value to divide by
      * \param msg Error message to print if test fails
      */
@@ -152,7 +152,7 @@
 
     t1 = Time(101LL * oneSec);
     NS_TEST_ASSERT_MSG_EQ((t2 % t1).GetSeconds(), 81, "Remainder Operation (2000 % 101 = 81)");
-    NS_TEST_ASSERT_MSG_EQ(Div(t2, t1), 19, "Modular Divison");
+    NS_TEST_ASSERT_MSG_EQ(Div(t2, t1), 19, "Modular Division");
     NS_TEST_ASSERT_MSG_EQ(Rem(t2, t1).GetSeconds(), 81, "Remainder Operation (2000 % 101 = 81)");
 }
 
